/* 
	Project: Unicredit Prime Club Widget for Mac OS
	Document: Stuff to be known by both remote and local scripts (gets loaded first)
	Coder: http://mr-woodman.ru
*/


// By default, no internet and remote scripts
var remoteScripts = false;

/*
    Common
            */
            
/* Update all variable visuals (usually used at widget onLoad event)
and after all variable stuff has been inserted into page */
function updateVisuals()
{
    // Set appropriate height and position of content
    // with variable tab header
    setContentPaneBodySize();
    // Set "Special Offers" round corners of headers
	setCorners();
    // Bind city <select>'or to switch maps
    bindCitySelector();
    // Bind screen switcher
    bindScreenSwitchers();
    // Bind all .map .marker's
    bindMapMarkers();
    // Set first map to shwo
    setMapOfTheCity();
    // cufonize
    
}
function cufonAll()
{
    Cufon.replace('.content-pane a.link', { hover : true });
    Cufon.replace('.club-screen h3');
    Cufon.replace('.club-screen p');
    Cufon.replace('.club-screen li');
    Cufon.replace('.content-pane #to-list');
    Cufon.replace('.content-pane #to-map');
    Cufon.replace('.content-pane #to-club');
    Cufon.replace('.content-pane label');        
    Cufon.replace('.gloss-button');
    Cufon.replace('#unicredit-back h2');
    Cufon.replace('#unicredit-back p');
}

/* Switch PrimeClub screen */
function clubSwitch(id,scroll)
{
    // remove all cases
    $("#content-club").removeClass("club-main");
    // unselect old
    $(".club-screen.selected").removeClass("selected");
    // select new
    $("#"+id).addClass("selected");
    // if no scroll provided, scroll to the top
    if(scroll == undefined) scroll = 0;
    $("#content-club .body").scrollTop(scroll);
    // indicate special case screen
    if(id == "club-main") $("#content-club").addClass("club-main");
}

/* Set appropriate height and position of content
due to height variability of .content-pane .header */
function setContentPaneBodySize()
{
	// Through each .content-pane
	$(".content-pane").each(function() {
		// Skip maps - they have no .header
		if( !($(this).attr("id") == "content-map") )
		{
			// Get .header's height
			var h = parseInt($(this).children(".header").outerHeight());
			// Based on that, set .content-pane .body height and position
            if($(this).attr("id") == "content-club") h -= 5; // no margin for club content
			$(this).children(".body").attr("style","top: "+(h+5)+"px ; height: "+(290-h)+"px;");
		}
	});
}

/* Set round corners in headers 
of "Special Offers" section */
function setCorners()
{
    if($(".top-left-corner").size() > 0) return; // do not do work twice
    
	$("#content-special h3").each( function() {
		$(this).prepend("<div class='top-left-corner'></div>"+
						"<div class='top-right-corner'></div>"+
						"<div class='bottom-left-corner'></div>"+
						"<div class='bottom-right-corner'></div>");
	});
}

/*
    Maps update visuals scripts
                                    */

/* Bind onchange event of city <select>'or 
to show .map container of this city */
function bindCitySelector()
{
    // Unbind all old 'on change' events
    $("#city-select-wrapper select").unbind("change");
    // Bind new 'on change' event
	$("#city-select-wrapper select").change(function() {
		// Clear selection of maps
		$(".map.selected").removeClass("selected");
        // Set to default map screen, if we were in info-screen
        $("#content-map").removeClass("info-screen");
		// Set map of the <select>'ed city
		setMapOfTheCity();
	});
}
    
/* Bind click events to all markers on all maps 
to show pane with office info */
function bindMapMarkers()
{
    // Binding clicks
	$(".map .marker").click(function() {
		// Clear old selection
		$(".office.selected").removeClass("selected");
		// Set new selection
		$(this).parent(".office").addClass("selected");
		$("#content-map").removeClass("list-screen").addClass("info-screen");
	});
}

/* Init "to map" and "to list" buttons */
function bindScreenSwitchers()
{
    // Switch us to map screen
	$("#to-map").click(function() {
        // Hide unused screens
		$("#content-map").removeClass("info-screen list-screen");
		// Remove office selection
		$(".office.selected").removeClass("selected");
		return false;
	});
    
    // Switch us to office list screen
	$("#to-list").click(function() {
        // Hide unused screens
		$("#content-map").removeClass("info-screen");		
        // Clear old selection
		$(".office.selected").removeClass("selected");
        // Switch to list-screen
		$("#content-map").addClass("list-screen");
        // Scroll to Top
        $("#content-map .body").scrollTop(0);
		return false;
	});
}

function listSwitch()
{
    $("#content-map").removeClass("info-screen").addClass("list-screen");
}

function infoSwitch()
{
    $("#content-map").removeClass("list-screen").addClass("info-screen");
}

/* Show map of the currently <select>'ed city */
function setMapOfTheCity()
{
    var found = "";
    // Get currently <select>'ed city
	$("#city-select-wrapper select option:selected").each(function() {
		found = $(this).attr("value");
	});
    if(found != "") {
        // Show corresponding map
		$("#"+ found).addClass("selected");
        // Scroll to top (in case we were on list-screen)
        $("#content-map .body").scrollTop(0);
    }
    else {
        $("#city-select-wrapper select option:first").attr("selected","selected");
        $("#"+ $("#city-select-wrapper select option:first").attr("value") ).addClass("selected");
    }
}
