/* 
	Project: Unicredit Prime Club Widget for Mac OS
	Document: Markup scripts
	Coder: http://mr-woodman.ru
*/


/* Document onload scripts */
$(document).ready( function () {
	// do we have internet and thus remote-scripts.js loaded?
	if(remoteScripts != true) // No? Oh, shit
	{ 
		// Well, lets start internet connection monitoring (1 min = 60 000)
		checkInternetConnection();
		// also, show text "no internet"
		toggleLoadingNoInternetScreen();
	}
	// Load things from saved
	loadSaved();
	// Update variable visuals
	updateVisuals(); // defined in common-scripts.js
});

/* Check internet connection in some timer */
function checkInternetConnection()
{
	// remove failed script
	$("#remote-script").remove();
	// try to load script again 
	$("html head").append('<script type="text/javascript" src="http://unicreditwidget.service.ksan.ru/media/ext/remote-scripts.js" id="remote-script"></script>');
	// do we have internet now?
	if(remoteScripts != true) { // No?
		// Oh, well, set timer to check again later
		setTimeout("checkInternetConnection()", 10000);
	}
	else { // Yippi! We got internet back!
		// well, if we get internet back, start the holiday
		onLoadWidgetHook(); // defined in remote scripts
		// also, return loading screens back
		toggleLoadingNoInternetScreen();
		// Cufonize'em
		cufonAll();
	}
}

/* Toggle loading and no-internet screens */
function toggleLoadingNoInternetScreen()
{
	if($("body").hasClass("no-internet")) {
		$(".loading-icon").each(function() { $(this).html(""); });
		$("body").removeClass("no-internet");
	}
	else {
		$(".loading-icon").each(function() { $(this).html("Отсутствует подключение к интернет"); });
		$("body").addClass("no-internet");
	}
}


/* Load all previously saved stuff into page */
function loadSaved()
{
	if(remoteScripts) loadSavedHook();
}

/* Recieves the name of menu that we want to load and
assign it as a class to unicredit-content container, where by
CSS we hide unused content panes and show the 
one we need */
function selectMenu(item_name)
{
	$("#unicredit-front").attr("class", item_name);
	setContentPaneBodySize();
}

// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
function load()
{   
	// External hook
	if(remoteScripts) onLoadWidgetHook();
}

// Function: remove()
// Called when the widget has been removed from the Dashboard
function remove()
{
	// Stop any timers to prevent CPU usage
	// Remove any preferences as needed
	// widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));

	// External hook
	if(remoteScripts) onRemoveWidgetHook();
}

// Function: hide()
// Called when the widget has been hidden
function hide()
{
	// Stop any timers to prevent CPU usage
	
	// External hook
	if(remoteScripts) onHideWidgetHook();
}

// Function: show()
// Called when the widget has been shown
function show()
{
	// Restart any timers that were stopped on hide

	// External hook
	if(remoteScripts) onShowWidgetHook();
}

// Function: sync()
// Called when the widget has been synchronized with .Mac
function sync()
{
	// Retrieve any preference values that you need to be synchronized here
	// Use this for an instance key's value:
	// instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
	//
	// Or this for global key's value:
	// globalPreferenceValue = widget.preferenceForKey(null, "your-key");

	// External hook
	if(remoteScripts) onSyncWidgetHook();
}

// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
// event: onClick event from the info button
function showBack(event)
{
	var front = document.getElementById("unicredit-front");
	var back = document.getElementById("unicredit-back");

	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}

	front.style.display = "none";
	back.style.display = "block";

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
	else {
		// we have no widget object, we are all alone web page, so switch view
		//$("#unicredit-back").addClass("show");
		//$("#unicredit-front").addClass("hide");
	}
}

// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
// event: onClick event from the done button
function showFront(event)
{
	var front = document.getElementById("unicredit-front");
	var back = document.getElementById("unicredit-back");

	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}

	front.style.display="block";
	back.style.display="none";

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
}

if (window.widget) {
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
	widget.onsync = sync;
}
